//
// Author: Benjamin Langmann <b.langmann@gmx.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "helpers.h"
#include "stdafx.h"

#ifndef VFW_WIN
#include <math.h>
#include <sys/time.h>
#include <time.h>
#endif

// ----------------------
// some helper functions
// ----------------------

#ifndef VFW_WIN

/** counts time used between calls.
	call like:
	timing_data data;
	timing2k(&data, 0, "first point");
	// some actions A
	timing2k(&data, 1, "2. point");
	// more actions B
	timing2k(&data, 0, NULL);
	// again action A, str is ignored
	timing2k(&data, -1, NULL); // end, print results
*/
void timing2k(timing_data* data, int num, char* str) {
	struct timeval tmp;
	long curtime;
	int i;
	
	if (num<-1 || num>=MAX_TIMES) {
		printf("timing: Error bad number: %d\n", num);
		return;
	}
	
	gettimeofday(&tmp,NULL);
	curtime=tmp.tv_sec*1000000+tmp.tv_usec;
	
	if (data->init!=3434343) {	// init
		for (i=0;i<MAX_TIMES;i++) {
			data->times[i]=0;
			data->times_str[i][0]='\0';
			data->times_num[i]=0;
		}
		data->init=3434343;
		data->last_num=num;
		data->last_time=curtime;
		
		sprintf(data->times_str[num],"%s",str);
	}
	else {
		if (num==-1) { // end
			data->times_num[data->last_num]++;
			data->times[data->last_num]+=curtime-data->last_time;
			curtime=0;
			for (i=0;i<MAX_TIMES;i++) {
				curtime+=data->times[i];
				if (data->times_num[i]!=0) printf("%s : count: %d time: %f s\n",data->times_str[i], data->times_num[i], data->times[i]/1000000.0);
			}
			printf("all : %f s\n",curtime/1000000.0);
			data->init=0;
			//printf("*******************************************\n");
			//printf("Mallocs: %d  Frees: %d\n",mallocs,frees);
			//printf("*******************************************\n");
		}
		else {
			if (data->times_num[num]==0) sprintf(data->times_str[num],"%s",str);
			
			data->times_num[data->last_num]++;
			data->times[data->last_num]+=curtime-data->last_time;
			data->last_num=num;
			data->last_time=curtime;
		}
	}	
}

#endif

