//
// Author: Benjamin Langmann <b.langmann@gmx.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef LMJPEG_IMAGE_H
#define LMJPEG_IMAGE_H

#include "stdafx.h"
#include "lmjpeg_encoder.h"
#include "lmjpeg_io.h"
#include "helpers.h"

void set_image_properties(CODEC *codec);
int get_image_size(CODEC *codec);
int get_image_size_fmt(CODEC *codec, int pix_format);
int get_block_count(CODEC *codec);

void lmjpeg_img_convert_to_internal(CODEC *codec, uint8_t *in, uint8_t *out);
void lmjpeg_img_convert_to_external(CODEC *codec, uint8_t *in, uint8_t *out);
void lmjpeg_img_expand(CODEC *codec, uint8_t *in, uint8_t *adjin);
void lmjpeg_img_shrink(CODEC *codec, uint8_t *nadjout, uint8_t *out);
void lmjpeg_img_flip(CODEC *codec, uint8_t *img);

#endif
