#!/usr/bin/perl -w

$lmjpeg="../../optimized/src/lmjpeg";
$workdir="/mnt/wind/upload/test/Testvideos";
$outputdir="/mnt/wine/test";

$stats="mmnew.csv";
$keepfiles=100;	# only keep files smaller _ MB
$start=1;

@infiles=("mm-260505_tscc_1000_huff.avi");

#@infiles=("mm-260505_tscc_1000_huff.avi","ac10_30s.avi","heute_huff_46s.avi","terminal_t60_640_huff.avi");
@q1=(5,10,30);
@q2=(2,5,10);
@qdiff=(1,10,30);
@jpeg=(1,4,8,18,100);
@keyf=(100);
@comp=("RLE");
@sam=("420");
@pix=("YUV");#,"RGB","BGR");

$number=1;
$enc_times=($#infiles+1)*(($#qdiff+1))*($#jpeg+1)*($#keyf+1)*($#comp+1)*($#sam+1)*($#pix+1);
print "there will be ".$enc_times." encodings\n";
open OUTPUT,">$stats" or print "Error opening output file!\n";
printf(OUTPUT "#Number,Input name,Output name,Mode,Quality 1,Quality 2,Quantizer,Keyframe intervall,Sampling,Pixel format,Compression,Size in KB,Encoding time,Total time,Command\n");

sub startlmjpeg {
	$in=shift;
	$mode=shift;
	$q1=shift;
	$q2=shift;
	$jpeg=shift;
	$keyf=shift;
	$comp=shift;
	$sam=shift;	
	$pix=shift;

	$out=sprintf("%s/%s_%s_%03s_%03s_%03s_%03s_%s_%s_%s.avi",$outputdir,$in,$mode,$q1,$q2,$jpeg,$keyf,$comp,$sam,$pix);
	if ($jpeg == 100) {
		$cmd="$lmjpeg -quality_mode $mode -quality $q1 $q2 -jpeg_quality $jpeg -keyframe $keyf -compression $comp -sampling $sam -pix_format $pix write $workdir/$in $out";
	}
	else {	
		$cmd="$lmjpeg -quality_mode $mode -quality $q1 $q2 -mpeg_quant $jpeg -keyframe $keyf -compression $comp -sampling $sam -pix_format $pix write $workdir/$in $out";
	}

	$find=`./check $out`;
	print $find;

	if ($find eq "") {
		print "$out seems to be good!\n";
		$enctime=1;
		$extime=1;
	}	
	else {
		# exec and just print time
		$extime=`$cmd`;
		print $extime;
		$enctime=`echo \"$extime\" | grep \"lmjpeg: encode frame\"`;
		$enctime =~ s/^.*time:\ //;
		$enctime =~ s/\ s$//;
		$enctime =~ s/\n//sg;
		
		$extime=`echo \"$extime\" | grep \"coding time\"`;
		$extime =~ s/^.*time:\ //;
		$extime =~ s/\ s$//;
		$extime =~ s/\n//sg;
	}

	if (-e "$out") {$size=-s "$out";}
	else {$size=0;}
	printf(OUTPUT "%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n",$number,$in,$out,$mode,$q1,$q2,$jpeg,$keyf,$sam,$pix,$comp,$size/1024,$enctime,$extime,$cmd);
	
	print "*** done: $number time: $extime encodings left: ".($enc_times-$number);
	$sec=int((($enc_times-$number)*$extime)%60);
	$min=int(((($enc_times-$number)*$extime)/60)%60);
	$hrs=int((($enc_times-$number)*$extime)/3600);
	printf(" expected time left: %s:%02s:%02s",$hrs,$min,$sec);
	$sec=int(($enc_times*$extime)%60);
	$min=int((($enc_times*$extime)/60)%60);
	$hrs=int(($enc_times*$extime)/3600);
	printf(" expected total time: %s:%02s:%02s ***\n",$hrs,$min,$sec);
	print `df -h $out`;
	#if ($size/(1024*1024) > $keepfiles) {system "rm $out";}
}

sub waitfortemp {
	$name=shift;
	$temp=shift;
	
	$file=`find /sys -name "$name*" | grep "input"`;
	if ($file eq "") {
		print "temp. file not found!\n";
		return;
	}
	$acttemp=`cat $file`;

	while($acttemp/1000 > $temp) {
		print "waiting for: $temp, temp. now: $acttemp";
		sleep(10);
		$acttemp=`cat $file`;
	}
}

# mode PIX
#for ($i1=0;$i1<=$#infiles;$i1++) {
#	for ($i2=0;$i2<=$#q1;$i2++) {
#		for ($i3=0;$i3<=$#q2;$i3++) {
#			for ($i4=0;$i4<=$#jpeg;$i4++) {
#				for ($i5=0;$i5<=$#keyf;$i5++) {
#					for ($i7=0;$i7<=$#comp;$i7++) {
#						for ($i8=0;$i8<=$#sam;$i8++) {
#							for ($i6=0;$i6<=$#pix;$i6++) {
#								if ($number >= $start) {
#								startlmjpeg($infiles[$i1],"PIX",$q1[$i2],$q2[$i3],$jpeg[$i4],$keyf[$i5],$comp[$i7],$sam[$i8],$pix[$i6]);
#								}
#								$number++;
#							}
#						}
#					}
#				}
#			}
#		}
#	}
#}

# mode DIFF
for ($i1=0;$i1<=$#infiles;$i1++) {
	for ($i2=0;$i2<=$#qdiff;$i2++) {
			for ($i4=0;$i4<=$#jpeg;$i4++) {
				for ($i5=0;$i5<=$#keyf;$i5++) {
					for ($i7=0;$i7<=$#comp;$i7++) {
						for ($i8=0;$i8<=$#sam;$i8++) {
							for ($i6=0;$i6<=$#pix;$i6++) {
								if ($number >= $start) {
									startlmjpeg($infiles[$i1],"DIFF",0,$qdiff[$i2],$jpeg[$i4],$keyf[$i5],$comp[$i7],$sam[$i8],$pix[$i6]);
									#waitfortemp("temp2", 60);
								}
								$number++;
							}
						}
					}
				}
			}
#		}
	}
}

close OUTPUT;
