
#include <stdio.h>
#include <stdint.h>

typedef uint32_t DWORD;

#define AVI_HEADERSIZE  2048                    // size of AVI header list

/* Flags for index */
#define AVIIF_LIST          0x00000001L // chunk is a 'LIST'
#define AVIIF_KEYFRAME      0x00000010L // this frame is a key frame.
#define AVIIF_FIRSTPART     0x00000020L // this frame is the start of a partial frame.
#define AVIIF_LASTPART      0x00000040L // this frame is the end of a partial frame.
#define AVIIF_MIDPART       (AVIIF_LASTPART|AVIIF_FIRSTPART)

#define AVIIF_NOTIME	    0x00000100L // this frame doesn't take any time
#define AVIIF_COMPUSE       0x0FFF0000L // these bits are for compressor use

typedef struct {
	DWORD		ckid;
	DWORD		dwFlags;
	DWORD		dwChunkOffset;		// Position of chunk
	DWORD		dwChunkLength;		// Length of chunk
} lmjpeg_AVIINDEXENTRY;



int main(int argc, char **argv) {
	FILE *reader,*writer;
	int written=0, ret;
	DWORD tmp;
	long index_start;
	char ch[4], *filename=argv[1];
	//printf("fix: %s\n", filename);

	// set up writer
	//index_start=ftell(codec->lmjpeg_file);
	//fseek(codec->lmjpeg_file,8,SEEK_CUR);
	
	// set up reader
	reader=fopen(filename,"rb");
	if (reader==NULL) {
		printf("Error opening %s!\n",filename);
		return -1;
	}
	fseek(reader,AVI_HEADERSIZE+4,SEEK_SET);
	
	ret=fread(&tmp,1,4,reader);
	if (ret!=4) {
		printf("Error reading. %s!\n",filename);
		fclose(reader);
		return -1;
	}
	fseek(reader,tmp,SEEK_CUR);
	index_start=ftell(reader);
	//printf("Indexstart: %d\n", index_start);

	ret=fread(ch,1,4,reader);
	if (ret!=4) {
		printf("Error reading. %s!\n",filename);
		fclose(reader);
		return -1;
	}
	
	if (ch[0]!='i' || ch[1]!='d' || ch[2]!='x' || ch[3]!='1') {
		printf("Error did not find index. %s!\n",filename);
	}
	


	//printf("id: %x flags: %x off: %d length: %d\n", idx.ckid, idx.dwFlags, idx.dwChunkOffset, idx.dwChunkLength);
	fclose(reader);

	return 0;
}
